## Qdu service

Qdu service — Support for the Qdu service.

## Functions

MbimMessage * | mbim_message_qdu_update_session_query_new ()
MbimMessage * | mbim_message_qdu_update_session_set_new ()
gboolean | mbim_message_qdu_update_session_response_parse ()
MbimMessage * | mbim_message_qdu_file_open_query_new ()
MbimMessage * | mbim_message_qdu_file_open_set_new ()
gboolean | mbim_message_qdu_file_open_response_parse ()
MbimMessage * | mbim_message_qdu_file_write_set_new ()
gboolean | mbim_message_qdu_file_write_response_parse ()
MbimMessage * | mbim_message_qdu_quectel_reboot_set_new ()
gboolean | mbim_message_qdu_quectel_reboot_response_parse ()
MbimMessage * | mbim_message_qdu_quectel_read_version_set_new ()
gboolean | mbim_message_qdu_quectel_read_version_response_parse ()
MbimMessage * | mbim_message_qdu_command_set_new ()
gboolean | mbim_message_qdu_command_response_parse ()

## Description

This section implements support for requests, responses and notifications in the Qdu service.

## Functions

### mbim_message_qdu_update_session_query_new ()

    MbimMessage *
    mbim_message_qdu_update_session_query_new
                                   (GError **error);

Create a new request for the 'Update Session' query command in the 'QDU' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_update_session_set_new ()

    MbimMessage *
    mbim_message_qdu_update_session_set_new
                                   (MbimQduSessionAction session_action,
                                    MbimQduSessionType session_type,
                                    GError **error);

Create a new request for the 'Update Session' set command in the 'QDU' service.

#### Parameters

session_action | the 'SessionAction' field, given as a MbimQduSessionAction. | [in]
session_type | the 'SessionType' field, given as a MbimQduSessionType. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_update_session_response_parse ()

    gboolean
    mbim_message_qdu_update_session_response_parse
                                   (const MbimMessage *message,
                                    MbimQduSessionType *out_current_session_type,
                                    MbimQduSessionStatus *out_current_session_status,
                                    MbimQduSessionType *out_last_session_type,
                                    MbimQduSessionResult *out_last_session_result,
                                    guint32 *out_last_session_error_offset,
                                    guint32 *out_last_session_error_size,
                                    GError **error);

Parses and returns parameters of the 'Update Session' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
out_current_session_type | return location for a MbimQduSessionType, or `NULL` if the 'CurrentSessionType' field is not needed. | [out][optional][transfer none]
out_current_session_status | return location for a MbimQduSessionStatus, or `NULL` if the 'CurrentSessionStatus' field is not needed. | [out][optional][transfer none]
out_last_session_type | return location for a MbimQduSessionType, or `NULL` if the 'LastSessionType' field is not needed. | [out][optional][transfer none]
out_last_session_result | return location for a MbimQduSessionResult, or `NULL` if the 'LastSessionResult' field is not needed. | [out][optional][transfer none]
out_last_session_error_offset | return location for a guint32, or `NULL` if the 'LastSessionErrorOffset' field is not needed. | [out][optional][transfer none]
out_last_session_error_size | return location for a guint32, or `NULL` if the 'LastSessionErrorSize' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_qdu_file_open_query_new ()

    MbimMessage *
    mbim_message_qdu_file_open_query_new (GError **error);

Create a new request for the 'File Open' query command in the 'QDU' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_file_open_set_new ()

    MbimMessage *
    mbim_message_qdu_file_open_set_new (MbimQduFileType file_type,
                                        guint32 file_size,
                                        GError **error);

Create a new request for the 'File Open' set command in the 'QDU' service.

#### Parameters

file_type | the 'FileType' field, given as a MbimQduFileType. | [in]
file_size | the 'FileSize' field, given as a guint32. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_file_open_response_parse ()

    gboolean
    mbim_message_qdu_file_open_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_max_transfer_size,
                                    guint32 *out_max_window_size,
                                    GError **error);

Parses and returns parameters of the 'File Open' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
out_max_transfer_size | return location for a guint32, or `NULL` if the 'MaxTransferSize' field is not needed. | [out][optional][transfer none]
out_max_window_size | return location for a guint32, or `NULL` if the 'MaxWindowSize' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_qdu_file_write_set_new ()

    MbimMessage *
    mbim_message_qdu_file_write_set_new (const guint32 data_buffer_size,
                                         const guint8 *data_buffer,
                                         GError **error);

Create a new request for the 'File Write' set command in the 'QDU' service.

#### Parameters

data_buffer_size | size of the data_buffer array. | [in]
data_buffer | the 'DataBuffer' field, given as an array of guint8 values. | [in][element-type guint8][array length=data_buffer_size]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_qdu_file_write_response_parse ()

    gboolean
    mbim_message_qdu_file_write_response_parse
                                   (const MbimMessage *message,
                                    GError **error);

Parses and returns parameters of the 'File Write' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_qdu_quectel_reboot_set_new ()

    MbimMessage *
    mbim_message_qdu_quectel_reboot_set_new
                                   (MbimQduQuectelRebootType reboot_type,
                                    GError **error);

Create a new request for the 'Quectel Reboot' set command in the 'QDU' service.

#### Parameters

reboot_type | the 'RebootType' field, given as a MbimQduQuectelRebootType. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_qdu_quectel_reboot_response_parse ()

    gboolean
    mbim_message_qdu_quectel_reboot_response_parse
                                   (const MbimMessage *message,
                                    GError **error);

Parses and returns parameters of the 'Quectel Reboot' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_qdu_quectel_read_version_set_new ()

    MbimMessage *
    mbim_message_qdu_quectel_read_version_set_new
                                   (MbimQduQuectelVersionType version_type,
                                    GError **error);

Create a new request for the 'Quectel Read Version' set command in the 'QDU' service.

#### Parameters

version_type | the 'VersionType' field, given as a MbimQduQuectelVersionType. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_qdu_quectel_read_version_response_parse ()

    gboolean
    mbim_message_qdu_quectel_read_version_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_version_id,
                                    gchar **out_version,
                                    GError **error);

Parses and returns parameters of the 'Quectel Read Version' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
out_version_id | return location for a guint32, or `NULL` if the 'VersionId' field is not needed. | [out][optional][transfer none]
out_version | return location for a newly allocated string, or `NULL` if the 'Version' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_qdu_command_set_new ()

    MbimMessage *
    mbim_message_qdu_command_set_new (MbimQuectelCommandType command_type,
                                      const guint32 command_string_size,
                                      const guint8 *command_string,
                                      GError **error);

Create a new request for the 'Command' set command in the 'QDU' service.

#### Parameters

command_type | the 'CommandType' field, given as a MbimQuectelCommandType. | [in]
command_string_size | size of the command_string array. | [in]
command_string | the 'CommandString' field, given as an array of guint8 values. | [in][element-type guint8][array length=command_string_size]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.32

### mbim_message_qdu_command_response_parse ()

    gboolean
    mbim_message_qdu_command_response_parse
                                   (const MbimMessage *message,
                                    MbimQuectelCommandResponseStatus *out_command_response_status,
                                    guint32 *out_command_response_string_size,
                                    const guint8 **out_command_response_string,
                                    GError **error);

Parses and returns parameters of the 'Command' response command in the 'QDU' service.

#### Parameters

message | the MbimMessage. |
out_command_response_status | return location for a MbimQuectelCommandResponseStatus, or `NULL` if the 'CommandResponseStatus' field is not needed. | [out][optional][transfer none]
out_command_response_string_size | return location for the size of the command_response_string array. | [out][optional]
out_command_response_string | return location for an array of guint8 values. Do not free the returned value, it is owned by `message` . | [out][optional][transfer none][element-type guint8][array length=out_command_response_string_size]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.32